'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var core = require('@emotion/core');
var React = require('react');
var React__default = _interopDefault(React);

var css = function css() {
  return {
    width: "230px",
    height: "280px",
    backgroundColor: "#F8F9FA",
    boxShadow: "0 6px 10px 0 rgba(27, 32, 70, 0.09)",
    border: "1px solid #E1E4EB",
    color: "#545769",
    borderRadius: "4px",
    position: "relative",
    fontFamily: "Arial, Helvetica, sans-serif"
  };
};

var wrapperCss = function wrapperCss() {
  return {
    height: "40px",
    display: "flex",
    alignItems: "center",
    padding: "0 6px"
  };
};
var backIconCss = function backIconCss() {
  return {
    marginRight: "3px",
    cursor: "pointer"
  };
};

var css$1 = function css(props) {
  return {
    display: "flex",
    justifyContent: "space-between",
    alignItems: "center",
    cursor: "pointer",
    height: props.searchTerm !== "" ? "50px" : "30px",
    marginTop: "3px",
    padding: "0 6px",
    fontSize: "14px",
    "&:hover": {
      backgroundColor: "#ECEEF3"
    },
    "&:active": {
      backgroundColor: "#E1E4EB"
    }
  };
};

var css$2 = function css() {
  return {
    maxHeight: "203px",
    overflowY: "auto"
  };
};

var css$3 = function css() {
  return {
    width: "100%",
    height: "35px",
    paddingLeft: "35px",
    border: "1px solid #cfd1d2",
    borderRight: "none",
    borderLeft: "none",
    backgroundColor: "#F8F9FA",
    "&:focus": {
      outline: "none !important"
    },
    "&:active": {
      outline: "none !important"
    }
  };
};
var searchIconCss = function searchIconCss() {
  return {
    position: "absolute",
    top: "8px",
    left: "8px"
  };
};
var wrapperCss$1 = function wrapperCss() {
  return {
    position: "relative"
  };
};

var css$4 = function css() {
  return {
    display: "flex",
    flexDirection: "column",
    alignItems: "center",
    marginTop: "30px"
  };
};
var icon = function icon() {
  return {
    fontSize: "20px",
    marginBottom: "5px"
  };
};
var text = function text() {
  return {
    fontSize: "14px"
  };
};

var defaultStyles = {
  tree: css,
  header: wrapperCss,
  headerBackIcon: backIconCss,
  item: css$1,
  items: css$2,
  noResults: css$4,
  noResultsIcon: icon,
  noResultsText: text,
  input: css$3,
  searchInput: searchIconCss,
  inputWrapper: wrapperCss$1
};

var SearchedItem = function SearchedItem(_ref) {
  var _ref$item = _ref.item,
      item = _ref$item === void 0 ? [""] : _ref$item,
      _ref$searchIndex = _ref.searchIndex,
      searchIndex = _ref$searchIndex === void 0 ? 0 : _ref$searchIndex,
      _ref$searchTerm = _ref.searchTerm,
      searchTerm = _ref$searchTerm === void 0 ? "" : _ref$searchTerm;
  var leaf = item[item.length - 1];
  var parents = item.slice(0, item.length - 1).join(" / ");
  return React__default.createElement("div", null, React__default.createElement("div", null, React__default.createElement("span", null, leaf.substring(0, searchIndex)), React__default.createElement("span", null, React__default.createElement("b", null, leaf.substring(searchIndex, searchIndex + searchTerm.length))), React__default.createElement("span", null, leaf.substring(searchIndex + searchTerm.length))), React__default.createElement("div", null, parents));
};

var BasicItem = function BasicItem(_ref) {
  var _ref$label = _ref.label,
      label = _ref$label === void 0 ? "" : _ref$label;
  return React__default.createElement("span", null, label);
};

/** @jsx jsx */

var ItemRenderer = function ItemRenderer(props) {
  var getStyles = props.getStyles,
      _props$searchTerm = props.searchTerm,
      searchTerm = _props$searchTerm === void 0 ? "" : _props$searchTerm,
      _props$item = props.item;
  _props$item = _props$item === void 0 ? {
    item: [""],
    hasChild: false,
    currentDepth: 0
  } : _props$item;
  var item = _props$item.item,
      hasChild = _props$item.hasChild,
      currentDepth = _props$item.currentDepth,
      _onClick = props.onClick;
  var searchIndex = item[item.length - 1].toLowerCase().indexOf(searchTerm.trim().toLowerCase());
  return core.jsx("div", {
    onClick: function onClick() {
      return _onClick(item[currentDepth], item, hasChild);
    },
    css: getStyles("item", props)
  }, searchTerm !== "" && core.jsx(SearchedItem, {
    item: item,
    searchIndex: searchIndex,
    searchTerm: searchTerm.trim()
  }), searchTerm === "" && core.jsx(BasicItem, {
    label: item[currentDepth],
    searchIndex: searchIndex,
    searchTerm: searchTerm.trim()
  }), hasChild && core.jsx("span", null, "\u27A1\uFE0F"));
};

/** @jsx jsx */

var Header = function Header(props) {
  var _props$parents = props.parents,
      parents = _props$parents === void 0 ? [] : _props$parents,
      onClick = props.onClick,
      _props$title = props.title,
      title = _props$title === void 0 ? "" : _props$title,
      getStyles = props.getStyles;
  return core.jsx("div", {
    css: getStyles("header", props)
  }, parents.length > 0 && core.jsx(React__default.Fragment, null, core.jsx("span", {
    css: getStyles("headerBackIcon", props),
    onClick: onClick
  }, "\u2B05\uFE0F"), core.jsx("span", null, parents[parents.length - 1])), parents.length === 0 && core.jsx("span", null, title));
};

/** @jsx jsx */

var Input = function Input(props) {
  var searchTerm = props.searchTerm,
      setSearchTerm = props.setSearchTerm,
      getStyles = props.getStyles;
  return core.jsx("div", {
    css: getStyles("inputWrapper", props)
  }, core.jsx("span", {
    css: getStyles("searchInput", props)
  }, "\uD83D\uDD0D"), core.jsx("input", {
    css: getStyles("input", props),
    value: searchTerm,
    onChange: function onChange(e) {
      return setSearchTerm(e.target.value);
    }
  }));
};

/** @jsx jsx */

var NoResults = function NoResults(props) {
  var text = props.text,
      getStyles = props.getStyles;
  return core.jsx("div", {
    css: getStyles("noResults", props)
  }, core.jsx("div", {
    css: getStyles("noResultsIcon", props)
  }, "\u26A0\uFE0F"), core.jsx("div", {
    css: getStyles("noResultsText", props)
  }, text));
};

var containsAllParents = function containsAllParents(leaf, parents) {
  if (parents.length === 0) {
    return true;
  }

  var containsAll = true;
  parents.forEach(function (parent, index) {
    if (parent !== leaf[index]) {
      containsAll = false;
    }
  });
  return containsAll;
};
var filterBySearchTerm = function filterBySearchTerm(leaf, searchTerm) {
  return searchTerm === "" || leaf[leaf.length - 1].toLowerCase().includes(searchTerm.toLowerCase());
};
var buildLeafForItemRenderer = function buildLeafForItemRenderer(leaf, currentDepth, searchTerm) {
  return {
    item: leaf,
    hasChild: leaf.length - 1 > currentDepth && searchTerm === "",
    currentDepth: currentDepth,
    key: searchTerm === "" ? leaf[currentDepth] : leaf.slice().toString()
  };
};
var removeDuplicateLeafs = function removeDuplicateLeafs(leaves) {
  return leaves.filter(function (item, index) {
    return leaves.findIndex(function (leaf) {
      return leaf.key === item.key;
    }) === index;
  });
};

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var useLeavesManager = function useLeavesManager(_ref) {
  var structure = _ref.structure,
      parents = _ref.parents,
      currentDepth = _ref.currentDepth;

  var _useState = React.useState(""),
      _useState2 = _slicedToArray(_useState, 2),
      searchTerm = _useState2[0],
      setSearchTerm = _useState2[1];

  var _useState3 = React.useState([]),
      _useState4 = _slicedToArray(_useState3, 2),
      leaves = _useState4[0],
      setLeaves = _useState4[1];

  React.useEffect(function () {
    var leaves = structure.filter(function (leaf) {
      return filterBySearchTerm(leaf, searchTerm) && containsAllParents(leaf, parents);
    }).map(function (leaf) {
      return buildLeafForItemRenderer(leaf, currentDepth, searchTerm);
    });
    setLeaves(removeDuplicateLeafs(leaves));
  }, [searchTerm, parents, currentDepth]);
  return [searchTerm, setSearchTerm, leaves];
};

var useItemCallbacks = function useItemCallbacks(_ref) {
  var parents = _ref.parents,
      setParents = _ref.setParents,
      currentDepth = _ref.currentDepth,
      setCurrentDepth = _ref.setCurrentDepth,
      onSelect = _ref.onSelect;

  var onClick = function onClick(label, item, hasChild) {
    if (hasChild) {
      setParents(parents.concat(label));
      setCurrentDepth(currentDepth + 1);
    } else {
      onSelect(item);
    }
  };

  var onBackClick = function onBackClick() {
    setParents(parents.filter(function (parent, index) {
      return index < parents.length - 1;
    }));
    setCurrentDepth(currentDepth - 1);
  };

  return [onClick, onBackClick];
};

function _slicedToArray$1(arr, i) { return _arrayWithHoles$1(arr) || _iterableToArrayLimit$1(arr, i) || _nonIterableRest$1(); }

function _nonIterableRest$1() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit$1(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles$1(arr) { if (Array.isArray(arr)) return arr; }

var Tree = function Tree(props) {
  var _props$structure = props.structure,
      structure = _props$structure === void 0 ? [] : _props$structure,
      title = props.title,
      onSelect = props.onSelect,
      className = props.className,
      _props$noResultsText = props.noResultsText,
      noResultsText = _props$noResultsText === void 0 ? "No matching results" : _props$noResultsText,
      styles = props.styles,
      _props$headerRenderer = props.headerRenderer,
      Header$1 = _props$headerRenderer === void 0 ? Header : _props$headerRenderer,
      _props$inputRenderer = props.inputRenderer,
      Input$1 = _props$inputRenderer === void 0 ? Input : _props$inputRenderer,
      _props$noResultsRende = props.noResultsRenderer,
      NoResults$1 = _props$noResultsRende === void 0 ? NoResults : _props$noResultsRende,
      _props$itemRenderer = props.itemRenderer,
      Item = _props$itemRenderer === void 0 ? ItemRenderer : _props$itemRenderer;

  var _useState = React.useState(0),
      _useState2 = _slicedToArray$1(_useState, 2),
      currentDepth = _useState2[0],
      setCurrentDepth = _useState2[1];

  var _useState3 = React.useState([]),
      _useState4 = _slicedToArray$1(_useState3, 2),
      parents = _useState4[0],
      setParents = _useState4[1];

  var getStyles = function getStyles(key) {
    var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var base = defaultStyles[key](props);
    base.boxSizing = "border-box";
    var custom = props.styles && props.styles[key];
    return custom ? custom(base, props) : base;
  };

  var _useLeavesManager = useLeavesManager({
    structure: structure,
    parents: parents,
    currentDepth: currentDepth
  }),
      _useLeavesManager2 = _slicedToArray$1(_useLeavesManager, 3),
      searchTerm = _useLeavesManager2[0],
      setSearchTerm = _useLeavesManager2[1],
      leaves = _useLeavesManager2[2];

  var _useItemCallbacks = useItemCallbacks({
    parents: parents,
    setParents: setParents,
    currentDepth: currentDepth,
    setCurrentDepth: setCurrentDepth,
    onSelect: onSelect
  }),
      _useItemCallbacks2 = _slicedToArray$1(_useItemCallbacks, 2),
      onClick = _useItemCallbacks2[0],
      onBackClick = _useItemCallbacks2[1];

  return core.jsx("div", {
    css: getStyles("tree", props)
  }, core.jsx(Header$1, {
    parents: parents,
    title: title,
    onClick: onBackClick,
    getStyles: getStyles
  }, title), core.jsx(Input$1, {
    getStyles: getStyles,
    searchTerm: searchTerm,
    setSearchTerm: setSearchTerm
  }), core.jsx("div", {
    css: getStyles("items", props)
  }, leaves && leaves.length > 0 && leaves.map(function (item) {
    return core.jsx(Item, {
      getStyles: getStyles,
      searchTerm: searchTerm,
      item: item,
      onClick: onClick
    });
  }), leaves && leaves.length === 0 && core.jsx(NoResults$1, {
    text: noResultsText,
    getStyles: getStyles
  })));
};

exports.default = Tree;
