"use strict";

function _interopDefault(ex) {
  return ex && "object" == typeof ex && "default" in ex ? ex.default : ex;
}

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var core = require("@emotion/core"), React = require("react"), React__default = _interopDefault(React), css = function() {
  return {
    width: "230px",
    height: "280px",
    backgroundColor: "#F8F9FA",
    boxShadow: "0 6px 10px 0 rgba(27, 32, 70, 0.09)",
    border: "1px solid #E1E4EB",
    color: "#545769",
    borderRadius: "4px",
    position: "relative",
    fontFamily: "Arial, Helvetica, sans-serif"
  };
}, wrapperCss = function() {
  return {
    height: "40px",
    display: "flex",
    alignItems: "center",
    padding: "0 6px"
  };
}, backIconCss = function() {
  return {
    marginRight: "3px",
    cursor: "pointer"
  };
}, css$1 = function(props) {
  return {
    display: "flex",
    justifyContent: "space-between",
    alignItems: "center",
    cursor: "pointer",
    height: "" !== props.searchTerm ? "50px" : "30px",
    marginTop: "3px",
    padding: "0 6px",
    fontSize: "14px",
    "&:hover": {
      backgroundColor: "#ECEEF3"
    },
    "&:active": {
      backgroundColor: "#E1E4EB"
    }
  };
}, css$2 = function() {
  return {
    maxHeight: "203px",
    overflowY: "auto"
  };
}, css$3 = function() {
  return {
    width: "100%",
    height: "35px",
    paddingLeft: "35px",
    border: "1px solid #cfd1d2",
    borderRight: "none",
    borderLeft: "none",
    backgroundColor: "#F8F9FA",
    "&:focus": {
      outline: "none !important"
    },
    "&:active": {
      outline: "none !important"
    }
  };
}, searchIconCss = function() {
  return {
    position: "absolute",
    top: "8px",
    left: "8px"
  };
}, wrapperCss$1 = function() {
  return {
    position: "relative"
  };
}, css$4 = function() {
  return {
    display: "flex",
    flexDirection: "column",
    alignItems: "center",
    marginTop: "30px"
  };
}, icon = function() {
  return {
    fontSize: "20px",
    marginBottom: "5px"
  };
}, text = function() {
  return {
    fontSize: "14px"
  };
}, defaultStyles = {
  tree: css,
  header: wrapperCss,
  headerBackIcon: backIconCss,
  item: css$1,
  items: css$2,
  noResults: css$4,
  noResultsIcon: icon,
  noResultsText: text,
  input: css$3,
  searchInput: searchIconCss,
  inputWrapper: wrapperCss$1
}, SearchedItem = function(_ref) {
  var _ref$item = _ref.item, item = void 0 === _ref$item ? [ "" ] : _ref$item, _ref$searchIndex = _ref.searchIndex, searchIndex = void 0 === _ref$searchIndex ? 0 : _ref$searchIndex, _ref$searchTerm = _ref.searchTerm, searchTerm = void 0 === _ref$searchTerm ? "" : _ref$searchTerm, leaf = item[item.length - 1], parents = item.slice(0, item.length - 1).join(" / ");
  return React__default.createElement("div", null, React__default.createElement("div", null, React__default.createElement("span", null, leaf.substring(0, searchIndex)), React__default.createElement("span", null, React__default.createElement("b", null, leaf.substring(searchIndex, searchIndex + searchTerm.length))), React__default.createElement("span", null, leaf.substring(searchIndex + searchTerm.length))), React__default.createElement("div", null, parents));
}, BasicItem = function(_ref) {
  var _ref$label = _ref.label, label = void 0 === _ref$label ? "" : _ref$label;
  return React__default.createElement("span", null, label);
}, ItemRenderer = function(props) {
  var getStyles = props.getStyles, _props$searchTerm = props.searchTerm, searchTerm = void 0 === _props$searchTerm ? "" : _props$searchTerm, _props$item = props.item, item = (_props$item = void 0 === _props$item ? {
    item: [ "" ],
    hasChild: !1,
    currentDepth: 0
  } : _props$item).item, hasChild = _props$item.hasChild, currentDepth = _props$item.currentDepth, _onClick = props.onClick, searchIndex = item[item.length - 1].toLowerCase().indexOf(searchTerm.trim().toLowerCase());
  return core.jsx("div", {
    onClick: function() {
      return _onClick(item[currentDepth], item, hasChild);
    },
    css: getStyles("item", props)
  }, "" !== searchTerm && core.jsx(SearchedItem, {
    item: item,
    searchIndex: searchIndex,
    searchTerm: searchTerm.trim()
  }), "" === searchTerm && core.jsx(BasicItem, {
    label: item[currentDepth],
    searchIndex: searchIndex,
    searchTerm: searchTerm.trim()
  }), hasChild && core.jsx("span", null, "➡️"));
}, Header = function(props) {
  var _props$parents = props.parents, parents = void 0 === _props$parents ? [] : _props$parents, onClick = props.onClick, _props$title = props.title, title = void 0 === _props$title ? "" : _props$title, getStyles = props.getStyles;
  return core.jsx("div", {
    css: getStyles("header", props)
  }, parents.length > 0 && core.jsx(React__default.Fragment, null, core.jsx("span", {
    css: getStyles("headerBackIcon", props),
    onClick: onClick
  }, "⬅️"), core.jsx("span", null, parents[parents.length - 1])), 0 === parents.length && core.jsx("span", null, title));
}, Input = function(props) {
  var searchTerm = props.searchTerm, setSearchTerm = props.setSearchTerm, getStyles = props.getStyles;
  return core.jsx("div", {
    css: getStyles("inputWrapper", props)
  }, core.jsx("span", {
    css: getStyles("searchInput", props)
  }, "🔍"), core.jsx("input", {
    css: getStyles("input", props),
    value: searchTerm,
    onChange: function(e) {
      return setSearchTerm(e.target.value);
    }
  }));
}, NoResults = function(props) {
  var text = props.text, getStyles = props.getStyles;
  return core.jsx("div", {
    css: getStyles("noResults", props)
  }, core.jsx("div", {
    css: getStyles("noResultsIcon", props)
  }, "⚠️"), core.jsx("div", {
    css: getStyles("noResultsText", props)
  }, text));
}, containsAllParents = function(leaf, parents) {
  if (0 === parents.length) return !0;
  var containsAll = !0;
  return parents.forEach((function(parent, index) {
    parent !== leaf[index] && (containsAll = !1);
  })), containsAll;
}, filterBySearchTerm = function(leaf, searchTerm) {
  return "" === searchTerm || leaf[leaf.length - 1].toLowerCase().includes(searchTerm.toLowerCase());
}, buildLeafForItemRenderer = function(leaf, currentDepth, searchTerm) {
  return {
    item: leaf,
    hasChild: leaf.length - 1 > currentDepth && "" === searchTerm,
    currentDepth: currentDepth,
    key: "" === searchTerm ? leaf[currentDepth] : leaf.slice().toString()
  };
}, removeDuplicateLeafs = function(leaves) {
  return leaves.filter((function(item, index) {
    return leaves.findIndex((function(leaf) {
      return leaf.key === item.key;
    })) === index;
  }));
};

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

function _iterableToArrayLimit(arr, i) {
  if (Symbol.iterator in Object(arr) || "[object Arguments]" === Object.prototype.toString.call(arr)) {
    var _arr = [], _n = !0, _d = !1, _e = void 0;
    try {
      for (var _s, _i = arr[Symbol.iterator](); !(_n = (_s = _i.next()).done) && (_arr.push(_s.value), 
      !i || _arr.length !== i); _n = !0) ;
    } catch (err) {
      _d = !0, _e = err;
    } finally {
      try {
        _n || null == _i.return || _i.return();
      } finally {
        if (_d) throw _e;
      }
    }
    return _arr;
  }
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

var useLeavesManager = function(_ref) {
  var structure = _ref.structure, parents = _ref.parents, currentDepth = _ref.currentDepth, _useState2 = _slicedToArray(React.useState(""), 2), searchTerm = _useState2[0], setSearchTerm = _useState2[1], _useState4 = _slicedToArray(React.useState([]), 2), leaves = _useState4[0], setLeaves = _useState4[1];
  return React.useEffect((function() {
    var leaves = structure.filter((function(leaf) {
      return filterBySearchTerm(leaf, searchTerm) && containsAllParents(leaf, parents);
    })).map((function(leaf) {
      return buildLeafForItemRenderer(leaf, currentDepth, searchTerm);
    }));
    setLeaves(removeDuplicateLeafs(leaves));
  }), [ searchTerm, parents, currentDepth ]), [ searchTerm, setSearchTerm, leaves ];
}, useItemCallbacks = function(_ref) {
  var parents = _ref.parents, setParents = _ref.setParents, currentDepth = _ref.currentDepth, setCurrentDepth = _ref.setCurrentDepth, onSelect = _ref.onSelect;
  return [ function(label, item, hasChild) {
    hasChild ? (setParents(parents.concat(label)), setCurrentDepth(currentDepth + 1)) : onSelect(item);
  }, function() {
    setParents(parents.filter((function(parent, index) {
      return index < parents.length - 1;
    }))), setCurrentDepth(currentDepth - 1);
  } ];
};

function _slicedToArray$1(arr, i) {
  return _arrayWithHoles$1(arr) || _iterableToArrayLimit$1(arr, i) || _nonIterableRest$1();
}

function _nonIterableRest$1() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

function _iterableToArrayLimit$1(arr, i) {
  if (Symbol.iterator in Object(arr) || "[object Arguments]" === Object.prototype.toString.call(arr)) {
    var _arr = [], _n = !0, _d = !1, _e = void 0;
    try {
      for (var _s, _i = arr[Symbol.iterator](); !(_n = (_s = _i.next()).done) && (_arr.push(_s.value), 
      !i || _arr.length !== i); _n = !0) ;
    } catch (err) {
      _d = !0, _e = err;
    } finally {
      try {
        _n || null == _i.return || _i.return();
      } finally {
        if (_d) throw _e;
      }
    }
    return _arr;
  }
}

function _arrayWithHoles$1(arr) {
  if (Array.isArray(arr)) return arr;
}

var Tree = function(props) {
  var _props$structure = props.structure, structure = void 0 === _props$structure ? [] : _props$structure, title = props.title, onSelect = props.onSelect, _props$noResultsText = (props.className, 
  props.noResultsText), noResultsText = void 0 === _props$noResultsText ? "No matching results" : _props$noResultsText, _props$headerRenderer = (props.styles, 
  props.headerRenderer), Header$1 = void 0 === _props$headerRenderer ? Header : _props$headerRenderer, _props$inputRenderer = props.inputRenderer, Input$1 = void 0 === _props$inputRenderer ? Input : _props$inputRenderer, _props$noResultsRende = props.noResultsRenderer, NoResults$1 = void 0 === _props$noResultsRende ? NoResults : _props$noResultsRende, _props$itemRenderer = props.itemRenderer, Item = void 0 === _props$itemRenderer ? ItemRenderer : _props$itemRenderer, _useState2 = _slicedToArray$1(React.useState(0), 2), currentDepth = _useState2[0], setCurrentDepth = _useState2[1], _useState4 = _slicedToArray$1(React.useState([]), 2), parents = _useState4[0], setParents = _useState4[1], getStyles = function(key) {
    var props = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : {}, base = defaultStyles[key](props);
    base.boxSizing = "border-box";
    var custom = props.styles && props.styles[key];
    return custom ? custom(base, props) : base;
  }, _useLeavesManager2 = _slicedToArray$1(useLeavesManager({
    structure: structure,
    parents: parents,
    currentDepth: currentDepth
  }), 3), searchTerm = _useLeavesManager2[0], setSearchTerm = _useLeavesManager2[1], leaves = _useLeavesManager2[2], _useItemCallbacks2 = _slicedToArray$1(useItemCallbacks({
    parents: parents,
    setParents: setParents,
    currentDepth: currentDepth,
    setCurrentDepth: setCurrentDepth,
    onSelect: onSelect
  }), 2), onClick = _useItemCallbacks2[0], onBackClick = _useItemCallbacks2[1];
  return core.jsx("div", {
    css: getStyles("tree", props)
  }, core.jsx(Header$1, {
    parents: parents,
    title: title,
    onClick: onBackClick,
    getStyles: getStyles
  }, title), core.jsx(Input$1, {
    getStyles: getStyles,
    searchTerm: searchTerm,
    setSearchTerm: setSearchTerm
  }), core.jsx("div", {
    css: getStyles("items", props)
  }, leaves && leaves.length > 0 && leaves.map((function(item) {
    return core.jsx(Item, {
      getStyles: getStyles,
      searchTerm: searchTerm,
      item: item,
      onClick: onClick
    });
  })), leaves && 0 === leaves.length && core.jsx(NoResults$1, {
    text: noResultsText,
    getStyles: getStyles
  })));
};

exports.default = Tree;
